#include <vector>
#include <iostream>
using namespace std;

class Shape {
public:
  virtual void draw() = 0;
  virtual ~Shape() {};
};

class Circle : public Shape {
public:
  void draw() { cout << "Circle::draw" << endl; }
  ~Circle() { cout << "~Circle" << endl; }
};

class Triangle : public Shape {
public:
  void draw() { cout << "Triangle::draw" << endl; }
  ~Triangle() { cout << "~Triangle" << endl; }
};

class Square : public Shape {
public:
  void draw() { cout << "Square::draw" << endl; }
  ~Square() { cout << "~Square" << endl; }
};

int main(void) 
{
  typedef std::vector<Shape*> ShapeList;
  typedef ShapeList::iterator ShapeIter;
  ShapeList shapes;
  shapes.push_back(new Circle);
  shapes.push_back(new Square);
  shapes.push_back(new Triangle);
	
	ShapeIter begin = shapes.begin();
	ShapeIter end = shapes.end();
  while(begin !=end)
  	{
  	(*begin)->draw();
  	++begin;
  	}
	begin = shapes.begin();
	end = shapes.end();
  while(begin !=end)
  	{
  	delete (*begin);
  	++begin;
  	}

  return 0;
} 
